VERSION 5.00
Begin VB.UserControl RmFrame 
   Alignable       =   -1  'True
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   ClientHeight    =   996
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3132
   ControlContainer=   -1  'True
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ScaleHeight     =   996
   ScaleWidth      =   3132
   ToolboxBitmap   =   "RmFrame.ctx":0000
   Begin VB.Image picPicture 
      Enabled         =   0   'False
      Height          =   324
      Left            =   864
      Stretch         =   -1  'True
      Top             =   288
      Visible         =   0   'False
      Width           =   540
   End
End
Attribute VB_Name = "RmFrame"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : RmFrame VERSION 1.0.1
' DateTime  : 28/10/2002 15:40 (INITIAL VERSION)
' Author    : RadioMan
'             Asdrubal Velasquez
'             email:RadioMan@cantv.net
'
' Purpose   : Sustituto avanzado para reemplazar el Control Frame
'             de Visual Basic pero con esteroides
'             Enhanced substitute for VB Frame Control with steroids
'
'  Nota: Este control lo he construido desde la nada pero ha sido
'        depurado desde sus inicios ya que lo he mejorado mientras
'        lo utilizaba, originalmente era un Frame para sustituir
'        el control Frame del Visual Basic, pero con bordes modificables
'        sin embargo entre una funcionalidad y otra que le fu agregando
'        se convirti en algo mas que un simple Frame y puede
'        transformarse en apariencia  en otros controles segn
'        sea la necesidad.
'        Sus principales caractersticas son:
'        1.- Manejo de Font (Font)
'        2.- Sombreado del Texto (CaptionShadow) y distancia de la
'            sombra (ShadowOffsetX/ShadowOffsetY)
'        3.- Color del Texto (ForeColor)
'        4.- Alineacin del texto en todas las posiciones posibles
'            (Caption Align)
'        5.- Fondo slido o degradado de dos colores (BackgroundType)
'        6.- Estilo, ancho y tipo de borde (BorderStyle/BorderWidth/BorderType)
'        7.- Manejo de imgenes (Picture), con posicin
'            (PictureAlign) y dimensiones(PictureHeight/PictureWidth/PictureSize)
'            Tambien soporta margenes de la imagen
'            Autoescalado de la imagen al tamao del control
'        8.- Degradado de dos colores en fondo (GradientColor1/2)
'        9.- Posilidad de escribir el Caption rotado en cualquier
'            ngulo(CaptionRotationAngle)
'
'        Este control puede mimetizarse y convertirse sin mucho problema en:
'           a.- Boton sensible al mouse(En ejemplo)
'           b.- Fondos Degradados de ventanas o contenedor de controles
'           c.- Barra de Outlook ( Caption OutLook Bar)(En ejemplo)
'           d.- Botn Grfico (En ejemplo)
'           e.- Contenedor de Imagen sustituyendo al control Picture
'               pudiendo contener Iconos e imagenes de cualquier tipo
'               (ver Ejemplo)
'           f.- Frame configurable con varios tipos de Bordes(En ejemplo)
'           g.- Barra Lateral decorativa de ventana (En ejemplo)
'
'
'        USO DE ESTE CONTROL:Usted puede usar este control y su codigo
'        fuente de la manera que mejor le parezca.
'        Si hace una mejora al control, le agradecera muchsimo si
'        me proporciona una copia a radioman@cantv.net
'        Si lo usa, pudiera al menos mencionarme en los crditos ;-)
'
'        Si tiene alguna pregunta sobre el funcionamiento de este control
'        dirjame un mensaje a radioman@cantv.net y con gusto lo aclarar.
'
'        Este control se encuentra en continuo desarrollo. As que
'        pudiera ser que tenga una versin desactualizada.
'
'        La codificacin se entrega tal y como est y el autor no se
'        hace responsable por daos y problemas que puda ocasionarle
'
'
'  Notes: Thanks to Srideep Prasad / http://geocities.com/srideepprasad/
'         for the Gradient Functions (Faster), and Image functions
'
'         Thanks to Steve McManon / http://vbaccelerator.com
'         for the Rotated Text Function
'
'---------------------------------------------------------------------------------------
Option Explicit

'--------------------------------------------------
' PUBLIC VARIABLES
'--------------------------------------------------
Public Tag As Variant

'--------------------------------------------------
' EVENTS
'--------------------------------------------------
Public Event Click()
Public Event DblClick()
Public Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event Resize()

'--------------------------------------------------
' API CONSTANTS
'--------------------------------------------------
Private Const DT_CENTER = &H1
Private Const DT_VCENTER = &H4
Private Const DT_SINGLELINE = &H20
Private Const DT_RIGHT = &H2
Private Const DT_LEFT = &H0
Private Const DT_TOP = &H0
Private Const DT_BOTTOM = &H8

Private Const LF_FACESIZE = 32
'Private Const LOGPIXELSX = 88    '  Logical pixels/inch in X
Private Const LOGPIXELSY = 90    '  Logical pixels/inch in Y
Private Const FW_NORMAL = 400
Private Const FW_BOLD = 700

' Used with SetTextAlign
Private Const TA_BASELINE = 24
'Private Const TA_BOTTOM = 8
'Private Const TA_TOP = 0
Private Const TA_CENTER = 6
'Private Const TA_LEFT = 0
'Private Const TA_RIGHT = 2
'Private Const TA_NOUPDATECP = 0
Private Const VTA_BASELINE = TA_BASELINE
Private Const VTA_CENTER = TA_CENTER


'--------------------------------------------------
' PUBLIC ENUMERATIONS
'--------------------------------------------------
Public Enum enumCaptionAutoCenter
   eCaCNothing
   eCaCVertical
   eCaCHorizontal
   eCaCBoth
End Enum

Public Enum enumCaptionAligns
   eCaTopLeft = DT_TOP Or DT_LEFT
   eCaTopCenter = DT_TOP Or DT_CENTER
   eCaTopRight = DT_TOP Or DT_RIGHT
   eCaCenterLeft = DT_LEFT Or DT_VCENTER Or DT_SINGLELINE
   eCaCenterCenter = DT_CENTER Or DT_VCENTER Or DT_SINGLELINE
   eCaCenterRight = DT_RIGHT Or DT_VCENTER Or DT_SINGLELINE
   eCaBottomLeft = DT_BOTTOM Or DT_LEFT Or DT_SINGLELINE
   eCaBottomCenter = DT_BOTTOM Or DT_CENTER Or DT_SINGLELINE
   eCaBottomRight = DT_BOTTOM Or DT_RIGHT Or DT_SINGLELINE
End Enum

Public Enum enumBackgroundType
   eBtBackColor
   eBtGradientHorizontal
   eBtGradientVertical
End Enum

Public Enum enumPictureSize
   ePsSmall = 16
   ePsMedium = 20
   ePsLarge = 32
   ePsCustom = 99
   ePsStretch = 100
End Enum

Public Enum enumPictureAlign
   ePaCenter
   ePaLeft
   ePaRight
   ePaTop
   ePaBottom
End Enum

Public Enum enumBorderFlags
   BF_ADJUST = &H2000
   BF_BOTTOM = &H8
   BF_DIAGONAL = &H10
   BF_FLAT = &H4000
   BF_LEFT = &H1
   BF_MIDDLE = &H800
   BF_MONO = &H8000
   BF_RIGHT = &H4
   BF_SOFT = &H1000
   BF_TOP = &H2
   BF_BOTTOMLEFT = (BF_BOTTOM Or BF_LEFT)
   BF_BOTTOMRIGHT = (BF_BOTTOM Or BF_RIGHT)
   BF_DIAGONAL_ENDBOTTOMLEFT = (BF_DIAGONAL Or BF_BOTTOM Or BF_LEFT)
   BF_DIAGONAL_ENDBOTTOMRIGHT = (BF_DIAGONAL Or BF_BOTTOM Or BF_RIGHT)
   BF_DIAGONAL_ENDTOPLEFT = (BF_DIAGONAL Or BF_TOP Or BF_LEFT)
   BF_DIAGONAL_ENDTOPRIGHT = (BF_DIAGONAL Or BF_TOP Or BF_RIGHT)
   BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)
   BF_TOPLEFT = (BF_TOP Or BF_LEFT)
   BF_TOPRIGHT = (BF_TOP Or BF_RIGHT)
End Enum

Public Enum enumBorderTypes
   BDR_RAISEDINNER = &H4
   BDR_RAISEDOUTER = &H1
   BDR_SUNKENINNER = &H8
   BDR_SUNKENOUTER = &H2
   EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)
   EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
   EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
   EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)
End Enum


'--------------------------------------------------
' PRIVATES TYPES
'--------------------------------------------------
Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Type TRIVERTEX
   x As Long
   y As Long
   Red As Integer
   Green As Integer
   Blue As Integer
   Alpha As Integer
End Type

Private Type GRADIENT_RECT
   UpperLeft As Long
   LowerRight As Long
End Type

Private Type LOGFONT
   lfHeight As Long
   lfWidth As Long
   lfEscapement As Long
   lfOrientation As Long
   lfWeight As Long
   lfItalic As Byte
   lfUnderline As Byte
   lfStrikeOut As Byte
   lfCharSet As Byte
   lfOutPrecision As Byte
   lfClipPrecision As Byte
   lfQuality As Byte
   lfPitchAndFamily As Byte
   lfFaceName(LF_FACESIZE) As Byte
End Type


'--------------------------------------------------
' API DECLARATIONS
'--------------------------------------------------
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function SetTextAlign Lib "gdi32" (ByVal hdc As Long, ByVal wFlags As Long) As Long
Private Declare Function DrawEdge Lib "user32" (ByVal hdc As Long, qrc As RECT, ByVal edge As enumBorderTypes, ByVal grfFlags As enumBorderFlags) As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function GradientFill Lib "msimg32" (ByVal hdc As Long, ByRef pVertex As TRIVERTEX, ByVal dwNumVertex As Long, pMesh As Any, ByVal dwNumMesh As Long, ByVal dwMode As Long) As Integer
Private Declare Function OleTranslateColor Lib "OLEPRO32.DLL" (ByVal OLE_COLOR As Long, ByVal hPalette As Long, pccolorref As Long) As Long
Private Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function MulDiv Lib "kernel32" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long
' About Dialog
Private Declare Function SHAbout Lib "Shell32" Alias "ShellAboutA" (ByVal hOwner As Long, ByVal sAppName As String, ByVal sPrompt As String, ByVal hIcon As Long) As Long


'--------------------------------------------------
' Properties / Locals copies
'--------------------------------------------------
Private m_eBorderStyle As enumBorderTypes
Private m_lBorderWidth As Long
Private m_eBorderType As enumBorderFlags
Private m_bEnabled As Boolean
Private m_lBorderMarginTop As Long

' Caption properties variables
Private m_sCaption As String
Private m_bCaptionShadow As Boolean

Private m_iCaptionRotationAngle As Integer
Private m_lCaptionMarginLeft As Long
Private m_lCaptionMarginTop As Long
Private m_eCaptionAutoCenter As enumCaptionAutoCenter

Private m_eCaptionAlign As enumCaptionAligns
Private m_lShadowColor As OLE_COLOR

Private m_lGradientColor1 As OLE_COLOR
Private m_lGradientColor2 As OLE_COLOR
Private m_eBackGroundType As enumBackgroundType
Private m_lShadowOffsetX As Long
Private m_lShadowOffsetY As Long
Private m_lForeColor As OLE_COLOR
Private m_lBackColor As OLE_COLOR



' Image properties Variables
Private m_PictureSize As enumPictureSize
Private m_PictureHeight As Long
Private m_PictureWidth As Long
Private m_PictureAlign As enumPictureAlign

' Picture Margins
Private m_iPictureMarginLeft As Integer
Private m_iPictureMarginTop As Integer
Private m_iPictureMarginRight As Integer
Private m_iPictureMarginBottom As Integer



'---------------------------------------------------------------------------------------
' Procedure : AboutBox Function
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Function AboutBox()
   Dim oPic As StdPicture
   Set oPic = LoadResPicture("ICON", vbResIcon)
   SHAbout UserControl.hWnd, App.ProductName, App.CompanyName, oPic.Handle
   
   Set oPic = Nothing
End Function

'---------------------------------------------------------------------------------------
' Procedure : DrawBorders Sub
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Private Sub DrawBorders()
   Dim tRECT As RECT
   Dim l As Long
   Dim lOffsetOut As Long, lOffsetIn As Long
   
   With tRECT
      .Left = 0
      .Top = m_lBorderMarginTop
      .Right = (UserControl.ScaleWidth \ Screen.TwipsPerPixelX) - 0
      .Bottom = (UserControl.ScaleHeight \ Screen.TwipsPerPixelY) - 0
   End With
   
   For l = 1 To Int((m_lBorderWidth / 2) + 0.99)
      lOffsetOut = l - 1
      lOffsetIn = m_lBorderWidth - l
      DrawEdge UserControl.hdc, rectMake(tRECT.Left + lOffsetOut, tRECT.Top + lOffsetOut, tRECT.Right - lOffsetOut, tRECT.Bottom - lOffsetOut), m_eBorderStyle, m_eBorderType
      DrawEdge UserControl.hdc, rectMake(tRECT.Left + lOffsetIn, tRECT.Top + lOffsetIn, tRECT.Right - lOffsetIn, tRECT.Bottom - lOffsetIn), m_eBorderStyle, m_eBorderType
   Next l
   
End Sub

'---------------------------------------------------------------------------------------
' Procedure : DrawBackGround Sub
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Private Sub DrawBackGround()
   
   UserControl.Cls
   
   ' Draw a Gradient?
   If m_eBackGroundType = eBtGradientHorizontal Then
      DoGradientHorizontal m_lGradientColor1, m_lGradientColor2
      
   ElseIf m_eBackGroundType = eBtGradientVertical Then
      DoGradientVertical m_lGradientColor1, m_lGradientColor2
      
   ElseIf m_eBackGroundType = eBtBackColor Then
      UserControl.BackColor = m_lBackColor
      
      
   End If
   
End Sub

'---------------------------------------------------------------------------------------
' Procedure : DrawRotateText Sub
' DateTime  : 24/11/2002 11:14
' Purpose   : Draw Rotated Text
'
'            Thanks to Steve McManon / http://vbaccelerator.com
'---------------------------------------------------------------------------------------
'
Private Sub DrawRotateText()
   Dim tLF As LOGFONT
   Dim hFnt As Long
   Dim hFntOld As Long
   Dim lHeight As Long, lWidth As Long
   Dim lR As Long
   Dim CenterPointX As Single, CenterPointY As Single
   
   
   lHeight = UserControl.Height \ Screen.TwipsPerPixelY
   lWidth = UserControl.Width \ Screen.TwipsPerPixelX
   
   pOLEFontToLogFont UserControl.Font, UserControl.hdc, tLF
   tLF.lfEscapement = m_iCaptionRotationAngle * 10
   hFnt = CreateFontIndirect(tLF)
   
   
   ' Calculate Center point of control
   If m_eCaptionAutoCenter = eCaCNothing Then
      CenterPointX = m_lCaptionMarginLeft
      CenterPointY = m_lCaptionMarginTop
      
   ElseIf m_eCaptionAutoCenter = eCaCHorizontal Then
      CenterPointX = (UserControl.ScaleWidth / 2) / Screen.TwipsPerPixelX
      CenterPointY = m_lCaptionMarginTop
      
   ElseIf m_eCaptionAutoCenter = eCaCVertical Then
      CenterPointX = m_lCaptionMarginLeft
      CenterPointY = (UserControl.ScaleHeight / 2) / Screen.TwipsPerPixelY
      
   ElseIf m_eCaptionAutoCenter = eCaCBoth Then
      CenterPointX = (UserControl.ScaleWidth / 2) / Screen.TwipsPerPixelX
      CenterPointY = (UserControl.ScaleHeight / 2) / Screen.TwipsPerPixelY
   End If
   
   CenterPointX = CenterPointX + (UserControl.FontSize / 2)
   CenterPointY = CenterPointY + (UserControl.FontSize / 2)
   
   
   If (hFnt <> 0) Then
      hFntOld = SelectObject(hdc, hFnt)
      SetTextAlign UserControl.hdc, VTA_CENTER Or VTA_BASELINE
      
      lR = TextOut(UserControl.hdc, CenterPointX, CenterPointY, m_sCaption, Len(m_sCaption))
      
      SelectObject hdc, hFntOld
      DeleteObject hFnt
   End If
   
End Sub

'---------------------------------------------------------------------------------------
' Procedure : pOLEFontToLogFont Sub
' Purpose   : Convierte un Ole Font en LOGFONT
'
'            Thanks to Steve McManon / http://vbaccelerator.com
'---------------------------------------------------------------------------------------
'
Private Sub pOLEFontToLogFont(fntThis As StdFont, hdc As Long, tLF As LOGFONT)
   Dim sFont As String
   Dim iChar As Integer
   
   ' Convert an OLE StdFont to a LOGFONT structure:
   With tLF
      sFont = fntThis.Name
      ' There is a quicker way involving StrConv and CopyMemory, but
      ' this is simpler!:
      For iChar = 1 To Len(sFont)
         .lfFaceName(iChar - 1) = CByte(Asc(Mid$(sFont, iChar, 1)))
      Next iChar
      ' Based on the Win32SDK documentation:
      .lfHeight = -MulDiv((fntThis.Size), (GetDeviceCaps(hdc, LOGPIXELSY)), 72)
      .lfItalic = fntThis.Italic
      If (fntThis.Bold) Then
         .lfWeight = FW_BOLD
      Else
         .lfWeight = FW_NORMAL
      End If
      .lfUnderline = fntThis.Underline
      .lfStrikeOut = fntThis.Strikethrough
      
   End With
   
End Sub




'---------------------------------------------------------------------------------------
' Procedure : UserControl_AsyncReadComplete Sub
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Private Sub UserControl_AsyncReadComplete(AsyncProp As AsyncProperty)
   DrawControl
End Sub

'---------------------------------------------------------------------------------------
' Procedure : UserControl_InitProperties
' Purpose   : Initialize Properties of this control
'---------------------------------------------------------------------------------------
'
Private Sub UserControl_InitProperties()
   m_lBorderWidth = 1
   m_eBorderStyle = EDGE_ETCHED
   m_eBorderType = BF_RECT
   m_eCaptionAlign = eCaCenterCenter
   
   m_lBorderMarginTop = 0
   m_iCaptionRotationAngle = 0
   
   m_lCaptionMarginLeft = 0
   m_lCaptionMarginTop = 0
   
   m_eCaptionAutoCenter = eCaCNothing
   
   m_bEnabled = True
   m_lGradientColor1 = &HFF00&
   m_lGradientColor2 = &HC000&
   m_lBackColor = vbButtonFace
   '   SetBkColor UserControl.hdc, m_lBackColor
   UserControl.BackColor = m_lBackColor
   m_eBackGroundType = eBtBackColor
   m_bCaptionShadow = False
   m_lShadowOffsetX = 1
   m_lShadowOffsetY = 1
   m_lShadowColor = &H808080
   m_lForeColor = vbBlack
   m_PictureSize = ePsLarge
   m_PictureAlign = ePaRight
   m_PictureWidth = 32
   m_PictureHeight = 32
   
   ' Picture Margins
   m_iPictureMarginLeft = 0
   m_iPictureMarginRight = 0
   m_iPictureMarginTop = 0
   m_iPictureMarginBottom = 0
   
   
   
End Sub
'---------------------------------------------------------------------------------------
' Procedure : BorderType (Property Let/Get)
' Purpose   : Especifica cual es el tipo de borde del control
'             Specifies the type of border or frame
'---------------------------------------------------------------------------------------
'
Public Property Get BorderType() As enumBorderFlags
   BorderType = m_eBorderType
End Property

'---------------------------------------------------------------------------------------
' Procedure : BorderType (Property Let/Get)
' Purpose   : Especifica cual es el tipo de borde del control
'             Specifies the type of border or frame
'---------------------------------------------------------------------------------------
'
Public Property Let BorderType(newEdge As enumBorderFlags)
   
   m_eBorderType = newEdge
   DrawControl
   PropertyChanged "BorderType"
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : BorderWidth Property (Let/Get)
' Purpose   : Indica el ancho del borde del frame
'             Especifies the frame width border
'---------------------------------------------------------------------------------------
'
Public Property Get BorderWidth() As Long
   
   BorderWidth = m_lBorderWidth
   
End Property
'---------------------------------------------------------------------------------------
' Procedure : BorderWidth Property (Let/Get)
' Purpose   : Indica el ancho del borde del frame
'             Especifies the frame width border
'---------------------------------------------------------------------------------------
'
Public Property Let BorderWidth(ByVal newWidth As Long)
   m_lBorderWidth = newWidth
   DrawControl
   PropertyChanged "BorderWidth"
End Property

'---------------------------------------------------------------------------------------
' Procedure : DrawCaption
' Purpose   : Escribe el texto del control
'             Draw de caption of control
'---------------------------------------------------------------------------------------
'
Private Sub DrawCaption()
   
   If Len(m_sCaption) = 0 Then Exit Sub
   
   ' Draw caption shadow
   If m_iCaptionRotationAngle = 0 Then
      If m_bCaptionShadow Then
         SetTextColor UserControl.hdc, m_lShadowColor
         DrawText UserControl.hdc, m_sCaption, Len(m_sCaption), rectMake(m_lBorderWidth + m_lShadowOffsetX + m_lCaptionMarginLeft, m_lBorderWidth + m_lShadowOffsetY + m_lCaptionMarginTop, ScaleX(UserControl.Width, vbTwips, vbPixels) - m_lBorderWidth, ScaleY(UserControl.Height, vbTwips, vbPixels) - m_lBorderWidth), m_eCaptionAlign
      End If
   End If
   
   SetTextColor hdc, m_lForeColor
   
   ' Draw Caption
   If m_iCaptionRotationAngle = 0 Then
      DrawText UserControl.hdc, m_sCaption, Len(m_sCaption), rectMake(m_lBorderWidth + m_lCaptionMarginLeft, m_lBorderWidth + m_lCaptionMarginTop, ScaleX(UserControl.Width, vbTwips, vbPixels) - m_lBorderWidth, ScaleY(UserControl.Height, vbTwips, vbPixels) - m_lBorderWidth), m_eCaptionAlign
   Else
      DrawRotateText
   End If
   
End Sub

'---------------------------------------------------------------------------------------
' Procedure : DrawControl
' Purpose   : Dibuja el control, incluyendo los bordes y el caption
'             Draw the control, including caption and borders
'
'---------------------------------------------------------------------------------------
'
Private Sub DrawControl()
   Static bPainting As Boolean
   
   If Not bPainting Then
      bPainting = True
      
      DrawBackGround
      
      DrawPicture
      
      DrawCaption
      
      DrawBorders
      
      
      bPainting = False
   End If
   
End Sub
'---------------------------------------------------------------------------------------
' Procedure : BackColor Property (Let/Get)
' Purpose   : Exporta la propiedad BackColor de este control
'             Export BackColor Property
'
'---------------------------------------------------------------------------------------
'
Public Property Get BackColor() As OLE_COLOR
   
   BackColor = m_lBackColor
   
End Property
'---------------------------------------------------------------------------------------
' Procedure : BackColor Property (Let/Get)
' Purpose   : Exporta la propiedad BackColor de este control
'             Export BackColor Property
'
'---------------------------------------------------------------------------------------
'
Public Property Let BackColor(ByVal oNewBackColor As OLE_COLOR)
   
   m_lBackColor = oNewBackColor
   DrawControl
   PropertyChanged "BackColor"
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : rectMake
' Purpose   : Define una Linea recta en las estructura RECT
'             Define a rect line in RECT structure
'---------------------------------------------------------------------------------------
'
Private Function rectMake(ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long) As RECT
   
   Dim tRECT As RECT
   With tRECT
      .Bottom = lBottom
      .Top = lTop
      .Left = lLeft
      .Right = lRight
   End With
   rectMake = tRECT
   
End Function


'---------------------------------------------------------------------------------------
' Procedure : UserControl_Click
' Purpose   : Exporta el evento click
'             Exports clic event of this control
'---------------------------------------------------------------------------------------
'
Private Sub UserControl_Click()
   
   RaiseEvent Click
   
End Sub

'---------------------------------------------------------------------------------------
' Procedure : DoGradientHorizontal Sub
' Purpose   : Crea una degradacin de colores perfecta horizontal entre dos colores
'             Creates a perfect horizontal gradient between two colors
'
'  Notes: Agradecimientos a /Thanks to Srideep Prasad
'         http://geocities.com/srideepprasad/
'
'---------------------------------------------------------------------------------------
'
Private Sub DoGradientHorizontal(m_GradColor1 As OLE_COLOR, m_GradColor2 As OLE_COLOR)
   Dim Red As Integer, Green As Integer, Blue As Integer
   Dim RS As Integer, GS As Integer, BS As Integer
   Dim RGB1 As Long, RGB2 As Long
   
   RGB1 = TranslateColor(m_GradColor1)
   RS = UnRGB(RGB1, 0)
   GS = UnRGB(RGB1, 1)
   BS = UnRGB(RGB1, 2)
   
   RGB2 = TranslateColor(m_GradColor2)
   
   Red = UnRGB(RGB2, 0)
   Green = UnRGB(RGB2, 1)
   Blue = UnRGB(RGB2, 2)
   
   Dim Vert(2) As TRIVERTEX
   Dim GRect As GRADIENT_RECT
   Vert(0).Red = Val("&H" & Hex$((RS / 255) * 65534)): Vert(1).Red = Val("&H" & Hex$((Red / 255) * 65534))
   Vert(0).Green = Val("&H" & Hex$((GS / 255) * 65534)): Vert(1).Green = Val("&H" & Hex$((Green / 255) * 65534))
   Vert(0).Blue = Val("&H" & Hex$((BS / 255) * 65534)): Vert(1).Blue = Val("&H" & Hex$((Blue / 255) * 65534))
   
   With UserControl
      Vert(0).x = 0: Vert(1).x = ScaleX(.ScaleWidth, .ScaleMode, vbPixels)
      Vert(0).y = 0: Vert(1).y = ScaleY(.ScaleHeight, .ScaleMode, vbPixels)
      GRect.UpperLeft = 1
      GRect.LowerRight = 0
   End With
   
   GradientFill UserControl.hdc, Vert(0), 4, GRect, 1, 0
End Sub

'---------------------------------------------------------------------------------------
' Procedure : UnRGB Function
' Purpose   : La funcin contraria a RGB() de Visual Basic
'             Opposite function to RGB() from VB
'
'  Notes: Agradecimientos a /Thanks to Srideep Prasad
'         http://geocities.com/srideepprasad/
'
'---------------------------------------------------------------------------------------
'
Private Function UnRGB(ColorVal As Long, Part As Long) As Long
   Dim H As String, hexnum As String, outhex As String
   Dim Num As Integer, I As Integer
   H = Trim$(Hex$(ColorVal))
   For I = 1 To (6 - Len(H))
      H = "0" + H
   Next I
   Select Case 2 - Part
   Case Is = 0
      hexnum$ = Mid$(H, 1, 2)
   Case Is = 1
      hexnum$ = Mid$(H, 3, 2)
   Case Is = 2
      hexnum$ = Mid$(H, 5, 2)
   End Select
   outhex$ = UCase$(hexnum$)         ' Convert characters to uppercase
   Num = Val("&h" + outhex$)      ' &H tells VAL that A,B,C,to F are OK
   UnRGB = Num
   
End Function




'---------------------------------------------------------------------------------------
' Procedure : TranslateColor Function
' Purpose   : Convierte un OLE_COLOR a una estructura COLORREF
'             Converts an OLE_COLOR type to a COLORREF.
'
'  Notes: Agradecimientos a /Thanks to Srideep Prasad
'         http://geocities.com/srideepprasad/
'
'---------------------------------------------------------------------------------------
'
Private Function TranslateColor(ByVal oClr As OLE_COLOR, Optional hPal As Long = 0) As Long
   
   ' Convert Automation color to Windows color
   Dim CLR_INVALID As Long
   CLR_INVALID = -1
   If OleTranslateColor(oClr, hPal, TranslateColor) Then
      TranslateColor = CLR_INVALID
   End If
   
End Function



'---------------------------------------------------------------------------------------
' Procedure : DoGradientVertical Sub
' Purpose   : Crea una degradacin de colores perfecta Vertical entre dos colores
'             Creates a perfect vertical gradient between two colors
'
'  Notes: Agradecimientos a /Thanks to Srideep Prasad
'         http://geocities.com/srideepprasad/
'
'---------------------------------------------------------------------------------------
'
Private Sub DoGradientVertical(m_GradColor1 As OLE_COLOR, m_GradColor2 As OLE_COLOR)
   Dim Red As Integer, Green As Integer, Blue As Integer
   Dim RS As Integer, GS As Integer, BS As Integer
   Dim RGB1 As Long, RGB2 As Long
   
   RGB1 = TranslateColor(m_GradColor1)
   RS = UnRGB(RGB1, 0)
   GS = UnRGB(RGB1, 1)
   BS = UnRGB(RGB1, 2)
   
   RGB2 = TranslateColor(m_GradColor2)
   
   Red = UnRGB(RGB2, 0)
   Green = UnRGB(RGB2, 1)
   Blue = UnRGB(RGB2, 2)
   Dim Vert(2) As TRIVERTEX
   Dim GRect As GRADIENT_RECT
   Vert(0).Red = Val("&H" & Hex$((RS / 255) * 65534)): Vert(1).Red = Val("&H" & Hex$((Red / 255) * 65534))
   Vert(0).Green = Val("&H" & Hex$((GS / 255) * 65534)): Vert(1).Green = Val("&H" & Hex$((Green / 255) * 65534))
   Vert(0).Blue = Val("&H" & Hex$((BS / 255) * 65534)): Vert(1).Blue = Val("&H" & Hex$((Blue / 255) * 65534))
   
   With UserControl
      Vert(0).x = 0: Vert(1).x = ScaleX(.ScaleWidth, .ScaleMode, vbPixels)
      Vert(0).y = 0: Vert(1).y = ScaleY(.ScaleHeight, .ScaleMode, vbPixels)
      GRect.UpperLeft = 1
      GRect.LowerRight = 0
   End With
   
   GradientFill UserControl.hdc, Vert(0), 4, GRect, 1, 1
End Sub
'End Of Modified Code of the GradientFX Control

'---------------------------------------------------------------------------------------
' Procedure : UserControl_DblClick
' Purpose   : Exporta el evento click
'             Exports clic event of this control
'---------------------------------------------------------------------------------------
'
Private Sub UserControl_DblClick()
   
   RaiseEvent DblClick
   
   
End Sub
'---------------------------------------------------------------------------------------
' Procedure : BorderStyle Property (Let/Get)
' Purpose   : Asigna o lee la propiedad BorderStyle del control
'             Lets / Gets BorderStyle of this control
'
'---------------------------------------------------------------------------------------
'
Public Property Get BorderStyle() As enumBorderTypes
   
   BorderStyle = m_eBorderStyle
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : BorderStyle Property (Let/Get)
' Purpose   : Asigna o lee la propiedad BorderStyle del control
'             Lets / Gets BorderStyle of this control
'
'---------------------------------------------------------------------------------------
'
Public Property Let BorderStyle(ByVal New_BorderStyle As enumBorderTypes)
   
   m_eBorderStyle = New_BorderStyle
   DrawControl
   PropertyChanged "BorderStyle"
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : UserControl_MouseDown
' Purpose   : Expone el evento MOuseDown del control
'             Export the MouseDown Event
'
'---------------------------------------------------------------------------------------
'
Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
   
   RaiseEvent MouseDown(Button, Shift, x, y)
   
End Sub

'---------------------------------------------------------------------------------------
' Procedure : UserControl_MouseMove
' Purpose   : Expone el evento MouseMove del control
'             Export the MouseMove Event
'
'---------------------------------------------------------------------------------------
'
Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
   
   RaiseEvent MouseMove(Button, Shift, x, y)
   
End Sub

'---------------------------------------------------------------------------------------
' Procedure : UserControl_MouseUp
' Purpose   : Expone el evento MouseUp del control
'             Export the MouseUp Event
'
'---------------------------------------------------------------------------------------
'
Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
   
   RaiseEvent MouseUp(Button, Shift, x, y)
   
End Sub

'---------------------------------------------------------------------------------------
' Procedure : UserControl_ReadProperties
' Purpose   : Leer las propiedades almacenadas en el Bag
'             Loads property values from Property Bag
'---------------------------------------------------------------------------------------
'
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
   
   m_lBorderWidth = PropBag.ReadProperty("BorderWidth", 1)
   m_eBorderStyle = PropBag.ReadProperty("BorderStyle", 0)
   m_eBorderType = PropBag.ReadProperty("BorderType", BF_RECT)
   m_bEnabled = PropBag.ReadProperty("Enabled", True)
   m_sCaption = PropBag.ReadProperty("Caption", UserControl.Name)
   m_eCaptionAlign = PropBag.ReadProperty("CaptionAlign", enumCaptionAligns.eCaCenterCenter)
   m_iCaptionRotationAngle = PropBag.ReadProperty("CaptionRotationAngle", 0)
   m_eCaptionAutoCenter = PropBag.ReadProperty("CaptionAutoCenter", eCaCNothing)
   
   m_lCaptionMarginLeft = PropBag.ReadProperty("CaptionMarginLeft", 0)
   m_lCaptionMarginTop = PropBag.ReadProperty("CaptionMarginTop", 0)
   
   
   
   m_lBorderMarginTop = PropBag.ReadProperty("BorderMarginTop", 0)
   
   
   
   m_lBackColor = PropBag.ReadProperty("BackColor", vbButtonFace)
   UserControl.BackColor = m_lBackColor
   m_lForeColor = PropBag.ReadProperty("ForeColor", vbBlack)
   Set UserControl.Font = PropBag.ReadProperty("Font", Ambient.Font)
   m_lGradientColor1 = PropBag.ReadProperty("GradientColor1", &HFF00&)
   m_lGradientColor2 = PropBag.ReadProperty("GradientColor2", &HC000&)
   m_eBackGroundType = PropBag.ReadProperty("BackgroundType", enumBackgroundType.eBtBackColor)
   m_bCaptionShadow = PropBag.ReadProperty("CaptionShadow", False)
   m_lShadowOffsetX = PropBag.ReadProperty("ShadowOffsetX", 1)
   m_lShadowOffsetY = PropBag.ReadProperty("ShadowOffsetY", 1)
   m_lShadowColor = PropBag.ReadProperty("ShadowColor", &H808080)
   Set picPicture.Picture = PropBag.ReadProperty("Picture", Nothing)
   m_PictureSize = PropBag.ReadProperty("PictureSize", enumPictureSize.ePsLarge)
   m_PictureAlign = PropBag.ReadProperty("PictureAlign", enumPictureAlign.ePaRight)
   m_PictureWidth = PropBag.ReadProperty("PictureWidth", 32)
   m_PictureHeight = PropBag.ReadProperty("PictureHeight", 32)
   
   ' Picture Margins
   m_iPictureMarginLeft = PropBag.ReadProperty("PictureMarginLeft", 0)
   m_iPictureMarginRight = PropBag.ReadProperty("PictureMarginRight", 0)
   m_iPictureMarginTop = PropBag.ReadProperty("PictureMarginTop", 0)
   m_iPictureMarginBottom = PropBag.ReadProperty("PictureMarginBottom", 0)
   
   
End Sub

'---------------------------------------------------------------------------------------
' Procedure : UserControl_Resize
' Purpose   : Redibuja el control si recibe el evento Resize
'             Redraw the control when usercontrol is resized
'
'---------------------------------------------------------------------------------------
'
Private Sub UserControl_Resize()
   RaiseEvent Resize
   DrawControl
   
End Sub

Private Sub UserControl_Show()
   DrawControl
End Sub

'---------------------------------------------------------------------------------------
' Procedure : UserControl_WriteProperties
' Purpose   : Stores property values to Property Bag
'---------------------------------------------------------------------------------------
'
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
   
   Call PropBag.WriteProperty("BorderStyle", m_eBorderStyle, 0)
   Call PropBag.WriteProperty("BorderWidth", m_lBorderWidth, 1)
   Call PropBag.WriteProperty("BorderType", m_eBorderType, BF_RECT)
   Call PropBag.WriteProperty("Enabled", m_bEnabled, True)
   Call PropBag.WriteProperty("Caption", m_sCaption, UserControl.Name)
   Call PropBag.WriteProperty("CaptionAlign", m_eCaptionAlign, enumCaptionAligns.eCaCenterCenter)
   
   Call PropBag.WriteProperty("CaptionRotationAngle", m_iCaptionRotationAngle, 0)
   Call PropBag.WriteProperty("CaptionAutoCenter", m_eCaptionAutoCenter, eCaCNothing)
   
   
   Call PropBag.WriteProperty("CaptionMarginLeft", m_lCaptionMarginLeft, 0)
   Call PropBag.WriteProperty("CaptionMarginTop", m_lCaptionMarginTop, 0)
   
   Call PropBag.WriteProperty("BorderMarginTop", m_lBorderMarginTop, 0)
   Call PropBag.WriteProperty("BackColor", m_lBackColor, vbButtonFace)
   Call PropBag.WriteProperty("ForeColor", m_lForeColor, vbBlack)
   Call PropBag.WriteProperty("Font", UserControl.Font, Ambient.Font)
   Call PropBag.WriteProperty("GradientColor1", m_lGradientColor1, &HFF00&)
   Call PropBag.WriteProperty("GradientColor2", m_lGradientColor2, &HC000&)
   Call PropBag.WriteProperty("BackgroundType", m_eBackGroundType, enumBackgroundType.eBtBackColor)
   Call PropBag.WriteProperty("CaptionShadow", m_bCaptionShadow, False)
   Call PropBag.WriteProperty("ShadowOffsetX", m_lShadowOffsetX, 1)
   Call PropBag.WriteProperty("ShadowOffsetY", m_lShadowOffsetY, 1)
   Call PropBag.WriteProperty("ShadowColor", m_lShadowColor, &H808080)
   Call PropBag.WriteProperty("Picture", picPicture.Picture, Nothing)
   Call PropBag.WriteProperty("PictureSize", m_PictureSize, enumPictureSize.ePsLarge)
   Call PropBag.WriteProperty("PictureAlign", m_PictureAlign, enumPictureAlign.ePaRight)
   Call PropBag.WriteProperty("PictureWidth", m_PictureWidth, 32)
   Call PropBag.WriteProperty("PictureHeight", m_PictureHeight, 32)
   
   ' Picture Margins
   Call PropBag.WriteProperty("PictureMarginLeft", m_iPictureMarginLeft, 0)
   Call PropBag.WriteProperty("PictureMarginRight", m_iPictureMarginRight, 0)
   Call PropBag.WriteProperty("PictureMarginTop", m_iPictureMarginTop, 0)
   Call PropBag.WriteProperty("PictureMarginBottom", m_iPictureMarginBottom, 0)
   
   
End Sub

'---------------------------------------------------------------------------------------
' Procedure : Enabled Property (Get/Let)
' Purpose   : Habilida o inhabilita el control
'             Enabled or Disabled the control
'
'---------------------------------------------------------------------------------------
'
Public Property Get Enabled() As Boolean
   
   Enabled = UserControl.Enabled
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : Enabled Property (Get/Let)
' Purpose   : Habilida o inhabilita el control
'             Enabled or Disabled the control
'
'---------------------------------------------------------------------------------------
'
Public Property Let Enabled(ByVal bEnabled As Boolean)
   
   UserControl.Enabled = bEnabled
   DrawControl
   PropertyChanged "Enabled"
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : hWnd Function
' Purpose   : Informa el hWnd del control
'             Get the hWnd of this control
'
'---------------------------------------------------------------------------------------
'
Public Property Get hWnd() As Long
   
   Dim lResult As Long
   lResult = UserControl.hWnd
   hWnd = lResult
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : hDc Function
' Purpose   : Informa del valor de hDc de este control
'             Gets the hDc value
'
'---------------------------------------------------------------------------------------
'
Public Property Get hdc() As Long
   
   Dim lResult As Long
   lResult = UserControl.hdc
   hdc = lResult
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : Caption Property (Get/Let)
' Purpose   : Asigna o lee el texto del control (caption)
'             Gets or Lets the caption property
'
'---------------------------------------------------------------------------------------
'
Public Property Get Caption() As String
   
   Caption = m_sCaption
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : Caption Property (Get/Let)
' Purpose   : Asigna o lee el texto del control (caption)
'             Gets or Lets the caption property
'
'---------------------------------------------------------------------------------------
'
Public Property Let Caption(ByVal sCaption As String)
   m_sCaption = sCaption
   DrawControl
   PropertyChanged "Caption"
End Property

'---------------------------------------------------------------------------------------
' Procedure : CaptionAlign Property
' Purpose   : La posicin del texto asignado en la propiedad caption
'             es modificada por esta propiedad, los valores son
'             determinados, por la enumeracin enumCaptionAligns
'             La propiedad CaptionAlign es ignorada cuando el ngulo de diferente de cero
'
'             The position of the text assigned in the property caption
'             is modified by this property, the values are determined,
'             by enumCaptionAligns
'             CaptionAlign Property is ignored when CaptionRotationAgle <> 0
'
'---------------------------------------------------------------------------------------
'
Public Property Get CaptionAlign() As enumCaptionAligns
   
   CaptionAlign = m_eCaptionAlign
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : CaptionAlign Property
' Purpose   : La posicin del texto asignado en la propiedad caption
'             es modificada por esta propiedad, los valores son
'             determinados, por la enumeracin enumCaptionAligns
'             La propiedad CaptionAlign es ignorada cuando el ngulo de diferente de cero
'
'             The position of the text assigned in the property caption
'             is modified by this property, the values are determined,
'             by enumCaptionAligns
'             CaptionAlign Property is ignored when CaptionRotationAgle <> 0
'
'---------------------------------------------------------------------------------------
'
Public Property Let CaptionAlign(ByVal eCaptionAlign As enumCaptionAligns)
   
   m_eCaptionAlign = eCaptionAlign
   DrawControl
   PropertyChanged "CaptionAlign"
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : ForeColor Property
' Purpose   : ForeColor es el color del texto de la propiedad Caption
'             ForeColor is the color of the text of the Caption property
'
'---------------------------------------------------------------------------------------
'
Public Property Get ForeColor() As OLE_COLOR
   
   ForeColor = m_lForeColor
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : ForeColor Property
' Purpose   : ForeColor es el color del texto de la propiedad Caption
'             ForeColor is the color of the text of the Caption property
'
'---------------------------------------------------------------------------------------
'
Public Property Let ForeColor(ByVal lForeColor As OLE_COLOR)
   
   m_lForeColor = lForeColor
   DrawControl
   PropertyChanged "ForeColor"
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : BorderMarginTop Property
' Purpose   : Esta propiedad determina cual es el margen superior
'             desde donde comenzar a dibujarse el borde del control.
'             Esta propiedad existe bsicamente para poder imitar las
'             caractersticas de un control Frame en su parte superior
'             para poder presentar el texto (caption) en la esquina
'             superior izquierda.
'
'             This property determines as it is the superior margin
'             from where the edge of the control will begin to draw
'             itself. This property exists basically to be able to
'             imitate the characteristics of a Frame control in its
'             superior part to be able to present/display the text
'             (caption) in the left superior corner
'
'---------------------------------------------------------------------------------------
'
Public Property Get BorderMarginTop() As Long
   
   BorderMarginTop = m_lBorderMarginTop
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : BorderMarginTop Property
' Purpose   : Esta propiedad determina cual es el margen superior
'             desde donde comenzar a dibujarse el borde del control.
'             Esta propiedad existe bsicamente para poder imitar las
'             caractersticas de un control Frame en su parte superior
'             para poder presentar el texto (caption) en la esquina
'             superior izquierda.
'
'             This property determines as it is the superior margin
'             from where the edge of the control will begin to draw
'             itself. This property exists basically to be able to
'             imitate the characteristics of a Frame control in its
'             superior part to be able to present/display the text
'             (caption) in the left superior corner
'
'---------------------------------------------------------------------------------------
'
Public Property Let BorderMarginTop(ByVal lBorderMarginTop As Long)
   
   m_lBorderMarginTop = lBorderMarginTop
   DrawControl
   PropertyChanged "BorderMarginTop"
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : Font Property
' Purpose   : Esta propiedad determina la apariencia de la letra del texto contenido en la propiedad Caption
'             This property determines the appearance of the letter of the text contained in the Caption property
'
'---------------------------------------------------------------------------------------
'
Public Property Get Font() As StdFont
   
   Set Font = UserControl.Font
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : Font Property
' Purpose   : Esta propiedad determina la apariencia de la letra del texto contenido en la propiedad Caption
'             This property determines the appearance of the letter of the text contained in the Caption property
'
'---------------------------------------------------------------------------------------
'
Public Property Set Font(objFont As StdFont)
   
   Set UserControl.Font = objFont
   DrawControl
   PropertyChanged "Font"
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : GradientColor1 Property
' Purpose   : Cuando la propiedad BackgroundType es eBtGradientHorizontal o eBtGradientVertical, esta propiedad determina cual es el color desde donde se comienza a degradar hasta el GradientColor2
'             When the BackgroundType property is eBtGradientHorizontal or eBtGradientVertical, this property determines as it is the color from where it is begun to degrade to the GradientColor2
'
'---------------------------------------------------------------------------------------
'
Public Property Get GradientColor1() As OLE_COLOR
   
   GradientColor1 = m_lGradientColor1
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : GradientColor1 Property
' Purpose   : Cuando la propiedad BackgroundType es eBtGradientHorizontal o eBtGradientVertical, esta propiedad determina cual es el color desde donde se comienza a degradar hasta el GradientColor2
'             When the BackgroundType property is eBtGradientHorizontal or eBtGradientVertical, this property determines as it is the color from where it is begun to degrade to the GradientColor2
'
'---------------------------------------------------------------------------------------
'
Public Property Let GradientColor1(ByVal lGradientColor1 As OLE_COLOR)
   
   m_lGradientColor1 = lGradientColor1
   DrawControl
   PropertyChanged "GradientColor1"
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : GradientColor2 Property
' Purpose   : Similar a la descripcin de GradientColor1
'             See GradientColor1 Property
'
'---------------------------------------------------------------------------------------
'
Public Property Get GradientColor2() As OLE_COLOR
   
   GradientColor2 = m_lGradientColor2
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : GradientColor2 Property
' Purpose   : Similar a la descripcin de GradientColor1
'             See GradientColor1 Property
'
'---------------------------------------------------------------------------------------
'
Public Property Let GradientColor2(ByVal lGradientColor2 As OLE_COLOR)
   
   m_lGradientColor2 = lGradientColor2
   DrawControl
   PropertyChanged "GradientColor2"
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : BackgroundType Property
' Purpose   : Determina que tipo de BackGround o apariencia de
'             fondo tendr el control.
'             It determines that type of BackGround or appearance
'             of bottom will have the control.
'---------------------------------------------------------------------------------------
'
Public Property Get BackgroundType() As enumBackgroundType
   
   BackgroundType = m_eBackGroundType
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : BackgroundType Property
' Purpose   : Determina que tipo de BackGround o apariencia de
'             fondo tendr el control.
'             It determines that type of BackGround or appearance
'             of bottom will have the control.
'---------------------------------------------------------------------------------------
'
Public Property Let BackgroundType(ByVal eBackGroundType As enumBackgroundType)
   
   m_eBackGroundType = eBackGroundType
   DrawControl
   PropertyChanged "BackgroundType"
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : CaptionShadow Property
' Purpose   : Determina si desea tener una sombra el texto de la
'             propiedad Caption
'             It determines if the text of the Caption property wishes
'             to have a shadow
'
'---------------------------------------------------------------------------------------
'
Public Property Get CaptionShadow() As Boolean
   
   CaptionShadow = m_bCaptionShadow
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : CaptionShadow Property
' Purpose   : Determina si desea tener una sombra el texto de la
'             propiedad Caption
'             It determines if the text of the Caption property wishes
'             to have a shadow
'
'---------------------------------------------------------------------------------------
'
Public Property Let CaptionShadow(ByVal bCaptionShadow As Boolean)
   
   m_bCaptionShadow = bCaptionShadow
   DrawControl
   PropertyChanged "CaptionShadow"
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : ShadowOffsetX/ShadowOffsetY Properties
' Purpose   : Determinan la distancia horizontal y vertical de la
'             posicin de la sombra (CaptionShadow) del texto (Caption)
'             They determine the horizontal range and vertical of the
'             position of the shade (CaptionShadow) of the text (Caption)
'
'---------------------------------------------------------------------------------------
'
Public Property Get ShadowOffsetX() As Long
   
   ShadowOffsetX = m_lShadowOffsetX
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : ShadowOffsetX/ShadowOffsetY Properties
' Purpose   : Determinan la distancia horizontal y vertical de la
'             posicin de la sombra (CaptionShadow) del texto (Caption)
'             They determine the horizontal range and vertical of the
'             position of the shade (CaptionShadow) of the text (Caption)
'
'---------------------------------------------------------------------------------------
'
Public Property Let ShadowOffsetX(ByVal lShadowOffsetX As Long)
   
   m_lShadowOffsetX = lShadowOffsetX
   DrawControl
   PropertyChanged "ShadowOffsetX"
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : ShadowOffsetX/ShadowOffsetY Properties
' Purpose   : Determinan la distancia horizontal y vertical de la
'             posicin de la sombra (CaptionShadow) del texto (Caption)
'             They determine the horizontal range and vertical of the
'             position of the shade (CaptionShadow) of the text (Caption)
'
'---------------------------------------------------------------------------------------
'
Public Property Get ShadowOffsetY() As Long
   
   ShadowOffsetY = m_lShadowOffsetY
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : ShadowOffsetX/ShadowOffsetY Properties
' Purpose   : Determinan la distancia horizontal y vertical de la
'             posicin de la sombra (CaptionShadow) del texto (Caption)
'             They determine the horizontal range and vertical of the
'             position of the shade (CaptionShadow) of the text (Caption)
'
'---------------------------------------------------------------------------------------
'
Public Property Let ShadowOffsetY(ByVal lShadowOffsetY As Long)
   
   m_lShadowOffsetY = lShadowOffsetY
   DrawControl
   PropertyChanged "ShadowOffsetY"
   
End Property


'---------------------------------------------------------------------------------------
' Procedure : ShadowColor Property
' Purpose   : Color de la sombra (CaptionShadow)
'             Shadow Color (CaptionShadow)
'
'---------------------------------------------------------------------------------------
'
Public Property Get ShadowColor() As OLE_COLOR
   
   ShadowColor = m_lShadowColor
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : ShadowColor Property
' Purpose   : Color de la sombra (CaptionShadow)
'             Shadow Color (CaptionShadow)
'
'---------------------------------------------------------------------------------------
'
Public Property Let ShadowColor(ByVal lShadowColor As OLE_COLOR)
   
   m_lShadowColor = lShadowColor
   DrawControl
   PropertyChanged "ShadowColor"
   
End Property
'---------------------------------------------------------------------------------------
' Procedure : Picture Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Get Picture() As Picture
   Set Picture = picPicture.Picture
End Property

'---------------------------------------------------------------------------------------
' Procedure : Picture Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Set Picture(ByVal NewPicture As Picture)
   Set picPicture.Picture = NewPicture
   DrawControl
   PropertyChanged "Picture"
End Property

'---------------------------------------------------------------------------------------
' Procedure : DrawPicture Sub
' Purpose   : Dibuja la imagen asignada a este control
'             Draw the picture on BackGround
'
'---------------------------------------------------------------------------------------
'
Private Sub DrawPicture()
   Dim H As Long, W As Long
   '   On Local Error Resume Next
   If picPicture.Picture = 0 Then Exit Sub
   
   ' Calculates Picture Size
   Select Case m_PictureSize
   Case ePsSmall, ePsMedium, ePsLarge
      H = m_PictureSize * Screen.TwipsPerPixelY
      W = m_PictureSize * Screen.TwipsPerPixelX
      m_PictureHeight = m_PictureSize
      m_PictureWidth = m_PictureSize
   Case ePsCustom
      H = m_PictureHeight * Screen.TwipsPerPixelY
      W = m_PictureWidth * Screen.TwipsPerPixelX
   Case ePsStretch
      H = ScaleHeight - ((m_iPictureMarginTop + m_iPictureMarginBottom) * Screen.TwipsPerPixelY)
      W = ScaleWidth - ((m_iPictureMarginLeft + m_iPictureMarginRight) * Screen.TwipsPerPixelX)
      m_PictureHeight = (H / Screen.TwipsPerPixelY)
      m_PictureWidth = (W / Screen.TwipsPerPixelX)
      PropertyChanged "PictureHeight"
      PropertyChanged "PictureWidth"
   End Select
   
   picPicture.Height = H
   picPicture.Width = W
   
   Select Case m_PictureAlign
      
   Case Is = ePaCenter
      With picPicture
         .Top = ((ScaleHeight - .Height) / 2) ' - ((m_iPictureMarginTop - m_iPictureMarginBottom) * Screen.TwipsPerPixelY)
         .Left = ((ScaleWidth - .Width) / 2) ' - ((m_iPictureMarginLeft - m_iPictureMarginRight) * Screen.TwipsPerPixelX)
      End With
      
   Case Is = ePaLeft
      With picPicture
         .Top = ((ScaleHeight - .Height) - ((m_iPictureMarginTop - m_iPictureMarginBottom) * Screen.TwipsPerPixelY)) / 2
         .Left = m_iPictureMarginLeft * Screen.TwipsPerPixelX
      End With
      
   Case Is = ePaRight
      With picPicture
         .Top = ((ScaleHeight - .Height) - ((m_iPictureMarginTop - m_iPictureMarginBottom) * Screen.TwipsPerPixelY)) / 2
         .Left = (ScaleWidth - .Width) - (m_iPictureMarginRight * Screen.TwipsPerPixelX)
      End With
      
   Case Is = ePaTop
      With picPicture
         .Top = m_iPictureMarginTop * Screen.TwipsPerPixelY
         .Left = ((ScaleWidth - .Width) - ((m_iPictureMarginLeft - m_iPictureMarginRight) * Screen.TwipsPerPixelX)) / 2
      End With
      
   Case Is = ePaBottom
      With picPicture
         .Top = (ScaleHeight - .Height) - m_iPictureMarginBottom * Screen.TwipsPerPixelX
         .Left = ((ScaleWidth - .Width) - ((m_iPictureMarginLeft - m_iPictureMarginRight) * Screen.TwipsPerPixelX)) / 2
      End With
   End Select
   
   PaintPicture picPicture.Picture, picPicture.Left, picPicture.Top, W, H
End Sub

'---------------------------------------------------------------------------------------
' Procedure : PictureWidth Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Get PictureWidth() As Long
   PictureWidth = m_PictureWidth
End Property

'---------------------------------------------------------------------------------------
' Procedure : PictureWidth Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Let PictureWidth(ByVal New_PictureWidth As Long)
   m_PictureWidth = New_PictureWidth
   m_PictureSize = ePsCustom
   DrawControl
   PropertyChanged "PictureWidth"
   PropertyChanged "PictureSize"
End Property

'---------------------------------------------------------------------------------------
' Procedure : PictureHeight Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Get PictureHeight() As Long
   PictureHeight = m_PictureHeight
End Property

'---------------------------------------------------------------------------------------
' Procedure : PictureHeight Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Let PictureHeight(ByVal New_PictureHeight As Long)
   m_PictureHeight = New_PictureHeight
   m_PictureSize = ePsCustom
   DrawControl
   PropertyChanged "PictureHeight"
   PropertyChanged "PictureSize"
End Property

'---------------------------------------------------------------------------------------
' Procedure : PictureAlign Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Get PictureAlign() As enumPictureAlign
   PictureAlign = m_PictureAlign
End Property

'---------------------------------------------------------------------------------------
' Procedure : PictureAlign Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Let PictureAlign(ByVal New_PictureAlign As enumPictureAlign)
   m_PictureAlign = New_PictureAlign
   DrawControl
   PropertyChanged "PictureAlign"
End Property

'---------------------------------------------------------------------------------------
' Procedure : PictureSize Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Get PictureSize() As enumPictureSize
   PictureSize = m_PictureSize
End Property

'---------------------------------------------------------------------------------------
' Procedure : PictureSize Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Let PictureSize(ByVal New_PictureSize As enumPictureSize)
   m_PictureSize = New_PictureSize
   DrawControl
   PropertyChanged "PictureSize"
   PropertyChanged "PictureHeight"
   PropertyChanged "PictureWidth"
End Property



'---------------------------------------------------------------------------------------
' Procedure : PictureMarginLeft Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Get PictureMarginLeft() As Integer
   
   PictureMarginLeft = m_iPictureMarginLeft
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : PictureMarginLeft Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Let PictureMarginLeft(ByVal iPictureMarginLeft As Integer)
   
   m_iPictureMarginLeft = iPictureMarginLeft
   DrawControl
   Call UserControl.PropertyChanged("PictureMarginLeft")
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : PictureMarginTop Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Get PictureMarginTop() As Integer
   
   PictureMarginTop = m_iPictureMarginTop
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : PictureMarginTop Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Let PictureMarginTop(ByVal iPictureMarginTop As Integer)
   
   m_iPictureMarginTop = iPictureMarginTop
   DrawControl
   
   Call UserControl.PropertyChanged("PictureMarginTop")
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : PictureMarginRight Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Get PictureMarginRight() As Integer
   
   PictureMarginRight = m_iPictureMarginRight
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : PictureMarginRight Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Let PictureMarginRight(ByVal iPictureMarginRight As Integer)
   
   m_iPictureMarginRight = iPictureMarginRight
   DrawControl
   
   Call UserControl.PropertyChanged("PictureMarginRight")
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : PictureMarginBottom Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Get PictureMarginBottom() As Integer
   
   PictureMarginBottom = m_iPictureMarginBottom
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : PictureMarginBottom Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Let PictureMarginBottom(ByVal iPictureMarginBottom As Integer)
   
   m_iPictureMarginBottom = iPictureMarginBottom
   DrawControl
   
   Call UserControl.PropertyChanged("PictureMarginBottom")
   
End Property


'---------------------------------------------------------------------------------------
' Procedure : CaptionRotationAngle Property
' Purpose   : Indica el ngulo con el que se dibujar el texto (Caption)
'             Tells/Get Angle of rotated text
'
'---------------------------------------------------------------------------------------
'
Public Property Get CaptionRotationAngle() As Integer
   
   CaptionRotationAngle = m_iCaptionRotationAngle
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : CaptionRotationAngle Property
' Purpose   : Indica el ngulo con el que se dibujar el texto (Caption)
'             Tells/Get Angle of rotated text
'
'---------------------------------------------------------------------------------------
'
Public Property Let CaptionRotationAngle(ByVal iCaptionRotationAngle As Integer)
   
   m_iCaptionRotationAngle = iCaptionRotationAngle
   DrawControl
   Call UserControl.PropertyChanged("CaptionRotationAngle")
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : CaptionMarginLeft Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Get CaptionMarginLeft() As Long
   
   CaptionMarginLeft = m_lCaptionMarginLeft
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : CaptionMarginLeft Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Let CaptionMarginLeft(ByVal lCaptionMarginLeft As Long)
   
   m_lCaptionMarginLeft = lCaptionMarginLeft
   DrawControl
   Call UserControl.PropertyChanged("CaptionMarginLeft")
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : CaptionMarginTop Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Get CaptionMarginTop() As Long
   
   CaptionMarginTop = m_lCaptionMarginTop
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : CaptionMarginTop Property
' Purpose   :
'
'---------------------------------------------------------------------------------------
'
Public Property Let CaptionMarginTop(ByVal lCaptionMarginTop As Long)
   
   m_lCaptionMarginTop = lCaptionMarginTop
   DrawControl
   Call UserControl.PropertyChanged("CaptionMarginTop")
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : CaptionAutoCenter Property
' Purpose   : Esta propiedad permite centrar el texto cuando el
'             ngulo de rotacin es diferente de 0
'             La propiedad CaptionAlign es ignorada cuando el ngulo de diferente de cero
'
'---------------------------------------------------------------------------------------
'
Public Property Get CaptionAutoCenter() As enumCaptionAutoCenter
   
   CaptionAutoCenter = m_eCaptionAutoCenter
   
End Property

'---------------------------------------------------------------------------------------
' Procedure : CaptionAutoCenter Property
' Purpose   : Esta propiedad permite centrar el texto cuando el
'             ngulo de rotacin es diferente de 0.
'             La propiedad CaptionAlign es ignorada cuando el ngulo de diferente de cero
'
'---------------------------------------------------------------------------------------
'
Public Property Let CaptionAutoCenter(ByVal eCaptionAutoCenter As enumCaptionAutoCenter)
   
   m_eCaptionAutoCenter = eCaptionAutoCenter
   DrawControl
   Call UserControl.PropertyChanged("CaptionAutoCenter")
   
End Property


